import java.awt.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import java.io.*;

public class Brahman extends Frame {
  private SimpleUniverse u = null;
  private Room myRoom = null;
  private String path = null;
  private boolean pause=false, invertMouse=false, fullscreen=false, fullscreenArg=false, safeMode=false;
  private BranchGroup bg;
  private Rectangle geometry;
  private Image cursorImage;
  private Cursor cursor;
  private String cursorName = new String("cursor");
  private Insets insets;
  private Kshatriya player;
  private PhysicsHandler myPhysicsHandler;
  private InputHandler myInputHandler;

  Toolkit toolkit = Toolkit.getDefaultToolkit();
  Dimension resolution = toolkit.getScreenSize();
  int resX= (int)resolution.getWidth();
  int resY= (int)resolution.getHeight();

  public static void main(String[] args) {
    new Brahman(args);
  }
    
  public Brahman(String[] args) {
    super("hej tangent");
    setLayout(new BorderLayout());
    GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
    Canvas3D c = new Canvas3D( config );
    add("Center",c);

    u = new SimpleUniverse(c);
    u.getViewer().getView().setBackClipDistance(100.0);
	 u.getViewer().getView().setFrontClipDistance(.001f);
    bg = new BranchGroup();
    bg.setCapability(Group.ALLOW_CHILDREN_READ);
    bg.setCapability(Group.ALLOW_CHILDREN_WRITE);
    bg.setCapability(Group.ALLOW_CHILDREN_EXTEND);
    u.addBranchGraph(bg);		

    commandLineParser(args);

    myRoom = new Room( path ,this);
    bg.addChild(myRoom);
//    bg.compile();
    show();
    insets= this.getInsets();
	 setBounds( resX/4, resY/4, resX/2, resY/2 );
    if( fullscreenArg ) toggleFullscreen();
    hideCursor();
	 this.addWindowListener(new MyWindowListener());

    player = new Kshatriya(u);
    player.getHud().setCurrentDirText(path);
    myInputHandler = new InputHandler(c,player,this);
    myPhysicsHandler = new PhysicsHandler(player,this);
  }

  private void commandLineParser(String[] args) {
  for(int i=0;i<args.length;i++) {
    if(args[i].equals("-h")||args[i].equals("--help")||args[i].equals("-?")) {
      helpMessage();
    } else if(args[i].equals("-s")||args[i].equals("--safemode")) {
      safeMode=true;
    } else if(args[i].equals("-f")||args[i].equals("--fullscreen")) {
      fullscreenArg=true;
    } else if(args[i].equals("-i")||args[i].equals("--invertmouse")) {
      invertMouse=true;
    } else if(args[i].equals("-k")||args[i].equals("--keyboard")) {
      usageMessage();
    } else {
      File f= new File( args[i] );
      path=f.getAbsolutePath().toString();
    }
  }
  if(path == null) {
      try{
        path = System.getProperty("user.dir");  
      } catch (SecurityException se) {
        System.out.println("pwd failed, defualt is user home dir");
        path="user.home";
      }
    } 
  }

  void hideCursor() {
    cursorImage = toolkit.getImage("cursor.gif");
    MediaTracker mediaTracker = new MediaTracker(this);
    mediaTracker.addImage(cursorImage, 0);
    cursor = toolkit.createCustomCursor(cursorImage, new Point(0,0), cursorName);
    setCursor(cursor);
  }

  void toggleFullscreen() {
    if( !fullscreen ) {
      fullscreen= true;
      geometry=this.getBounds();
      setBounds( 0, 0, resX+insets.left+insets.right, resY+insets.top+insets.bottom );
    } else if( fullscreen ) {
      fullscreen= false;
      setBounds( geometry.x+insets.left, geometry.y+insets.top, geometry.width, geometry.height );
    }
  }

  public boolean getPause() { return pause; }

  public boolean getInvertMouse() { return invertMouse; }

  void togglePause() {
    if( !pause ) {
      pause=true;
      player.getHud().setCurrentDirText("Paused, press P to continue");
      setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
    } else if( pause ) {
      setCursor(cursor);
      pause=false;
      player.getHud().setCurrentDirText(path);
    }
  }
	
  Room getRoom() { return myRoom; }
    
  void setRoom(String path, float angle, String previousDir ) {
    pause=true;
    myRoom.detach();
    player.getHud().setCurrentDirText("loading: " + path);
    myRoom = new Room(path,this);
    bg.addChild(myRoom);
    player.getHud().setCurrentDirText(path);
    myRoom.setNewPositions( player, angle, previousDir );
    pause=false;
  }
 
  void helpMessage() {
  /* hej Niklas, vi vet att man kan anvnda \n och snt men det blir mer
     lsbart om vi skriver ut det p flera rader */
  System.out.println("Usage: bfm [PATH] [OPTIONS]");
  System.out.println("Delete your files in an brutal and entertaining way...");
  System.out.println("Options:");
  System.out.println("  -f, --fullscreen      start in fullscreen mode");
  System.out.println("  -h, --help            prints this message");
  System.out.println("  -i, --invertmouse     invert mouse");
  System.out.println("  -k, --keyboard        prints the default keyboard configuration");
  System.out.println("  -s, --safemode        safe mode, no files will be actually deleated");
  System.exit(0);
  }

  void usageMessage() {
  System.out.println("This is the standard keyboard configuration:");
  System.out.println("Forward           w");
  System.out.println("Backward          s");
  System.out.println("Strafe left       a");
  System.out.println("Strafe right      d");
  System.out.println("Look around       mouse");
  System.out.println("Run               shift, caps-lock");
  System.out.println("Fire              left mouse button");
  System.out.println("Jump              right mouse button, space");
  System.out.println("Crouch            ctrl");
  System.out.println("Select weapon     numbers 1-3 on the keyboard");
  System.out.println("  Spear           1");
  System.out.println("  Shotgun         2");
  System.out.println("  Sniper rifle    3");
  System.out.println("Fullscreen        f");
  System.out.println("Pause             p");
  System.out.println("Exit              esc");
  System.exit(0);
  }

  boolean getSafeMode() {return safeMode;} 
}
