import com.sun.j3d.utils.geometry.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Hud extends BranchGroup {
  private TransformGroup root;
  private Text2D currentDir;
  private TransformGroup moveText;
  private TransformGroup scaleText;
  private BranchGroup detach;

  public Hud() {
    setCapability(ALLOW_DETACH);
    setCapability(ALLOW_CHILDREN_WRITE);
    setCapability(ALLOW_CHILDREN_EXTEND);

    Transform3D t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(0,0,-1f));
    root = new TransformGroup(t3d);
    root.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
    root.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
    root.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
    t3d.rotY(Math.PI);

    t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(-0.35f,-0.25f,0));
    detach = new BranchGroup();
    detach.setCapability(ALLOW_DETACH);
    detach.setCapability(ALLOW_CHILDREN_WRITE);
    detach.setCapability(ALLOW_CHILDREN_EXTEND);
    moveText = new TransformGroup(t3d);

    t3d = new Transform3D();
    t3d.setScale(0.5f);
    scaleText = new TransformGroup(t3d);

    /* text2d */
    currentDir = new Text2D("",new Color3f(0,0.5f,0f),"Arial",12,Font.PLAIN);
    scaleText.addChild(currentDir); 
    moveText.addChild(scaleText);
    detach.addChild(moveText);
    root.addChild(detach);
    addChild(root);
  }

  void setCurrentDirText(String s) {
    detach.detach();
    scaleText.removeChild(currentDir);
    // currentDir.setString(s);
    currentDir= new Text2D(s,new Color3f(1f,1f,0f),"Arial",12,Font.PLAIN);
    scaleText.addChild(currentDir);
    root.addChild(detach);
  }
}


