import java.awt.*;
import java.awt.event.*;
import javax.media.j3d.*;

public class InputHandler implements KeyListener, MouseMotionListener, MouseListener {
  private Robot robot;
  private int pauseKey= KeyEvent.VK_P, 
              leftKey= KeyEvent.VK_A,
              rightKey= KeyEvent.VK_D, 
              forwardKey= KeyEvent.VK_W,
              backwardKey= KeyEvent.VK_S,
              fullscreenKey= KeyEvent.VK_F,
              quitKey= KeyEvent.VK_ESCAPE,
              jumpKey= KeyEvent.VK_SPACE,
              crouchKey= KeyEvent.VK_CONTROL,
              runKey= KeyEvent.VK_SHIFT,
              toggleRunKey= KeyEvent.VK_CAPS_LOCK,
              firstWeaponKey= KeyEvent.VK_1,
              secondWeaponKey= KeyEvent.VK_2,
              thirdWeaponKey= KeyEvent.VK_3,
              fourthWeaponKey= KeyEvent.VK_4;
  private int oldMousePosX=0, oldMousePosY=0, mouseDiffX=0,mouseDiffY=0, mouseMargin=100;
  private Canvas3D c3d;
  private Brahman motor;
  private Kshatriya spelare;

  public InputHandler (Canvas3D c,Kshatriya spelare,Brahman motor){
    c3d= c;
    c3d.addKeyListener( this);
    c3d.addMouseMotionListener(this);
    c3d.addMouseListener( this);
    c3d.requestFocus();
    try {
      robot = new Robot();
    } catch (Exception e) { System.out.println( "arrrgh!" ); }
    this.motor=motor;
    this.spelare=spelare;
    resetMouse();
  }

  public void keyTyped( KeyEvent ke ) {}

  public void keyPressed( KeyEvent ke){
    int keycode= ke.getKeyCode();
         if( keycode == leftKey ) spelare.setVelocityX(-spelare.speed);
    else if( keycode == rightKey ) spelare.setVelocityX(spelare.speed);
    else if( keycode == forwardKey ) spelare.setVelocityZ(spelare.speed);
    else if( keycode == backwardKey ) spelare.setVelocityZ(-spelare.speed);
    else if( keycode == firstWeaponKey ) spelare.setWeapon( new Spear() );
    else if( keycode == secondWeaponKey ) spelare.setWeapon( new Shotgun() );
    else if( keycode == thirdWeaponKey ) spelare.setWeapon( new SniperRifle() );
    else if( keycode == runKey && !spelare.crouching ) spelare.changeSpeed();
    else if( keycode == toggleRunKey && !spelare.crouching ) spelare.toggleRun();
    else if( keycode == pauseKey ) motor.togglePause();
    else if( keycode == fullscreenKey ) motor.toggleFullscreen();
    else if( keycode == jumpKey && !spelare.jumping && !spelare.crouching ) spelare.jump();
    else if( keycode == crouchKey && !spelare.crouching && !spelare.jumping ) spelare.toggleCrouch();
  }

  public void keyReleased( KeyEvent ke){
    int keycode= ke.getKeyCode();
         if( keycode == leftKey ) spelare.setVelocityX(0);
    else if( keycode == rightKey ) spelare.setVelocityX(0);
    else if( keycode == forwardKey ) spelare.setVelocityZ(0);
    else if( keycode == backwardKey ) spelare.setVelocityZ(0);
    else if( keycode == runKey && !spelare.crouching ) spelare.changeSpeed();
    else if( keycode == crouchKey && spelare.crouching ) spelare.toggleCrouch();
    else if( keycode == quitKey ) System.exit(0);
  }

  public void mouseDragged( MouseEvent me) {
    if( !motor.getPause() ) {
      mouseMoved( me );
    }
  }

  public void mouseMoved( MouseEvent me) {
    if( !motor.getPause() ) {
      if( me.getX()<mouseMargin || me.getX()>c3d.getWidth()-mouseMargin || me.getY()<mouseMargin || me.getY()>c3d.getHeight()-mouseMargin ) {
      resetMouse();
      } else if(!(me.getX()==c3d.getWidth()/2 && me.getY()==c3d.getHeight()/2)) {
        mouseDiffX = oldMousePosX - me.getX();
        mouseDiffY = oldMousePosY - me.getY();
        oldMousePosX = me.getX();
        oldMousePosY = me.getY();
        if( !motor.getInvertMouse() ) {
				  spelare.lookUp(mouseDiffY*spelare.mouseSpeed);
        } else {
				  spelare.lookUp(-1*mouseDiffY*spelare.mouseSpeed);
				}
				spelare.turnRight(mouseDiffX*spelare.mouseSpeed);
      }
    }
  }

  public void mouseClicked(MouseEvent me) {}

  public void mouseEntered(MouseEvent me) {}

  public void mouseExited(MouseEvent me) {}

  public void mousePressed(MouseEvent me) {
    if( !motor.getPause() ) {
      if(me.getButton()==me.BUTTON1) spelare.getWeapon().fire(motor.getRoom());
      if(me.getButton() == me.BUTTON3 && ( !spelare.jumping && !spelare.crouching )) {
        spelare.setVelocityY(spelare.speedJump);
        spelare.jumping=true;
      } 
    }
  }

  public void mouseReleased(MouseEvent me) {}

  public void resetMouse() {
    robot.mouseMove(c3d.getParent().getBounds().x+c3d.getWidth()/2,c3d.getParent().getBounds().y+c3d.getHeight()/2);
    oldMousePosX=c3d.getWidth()/2;
    oldMousePosY=c3d.getHeight()/2;
  }
}
