import com.sun.j3d.utils.universe.*; 
import javax.media.j3d.*;
import javax.vecmath.*;

public class Kshatriya extends BranchGroup {
  public float height=1.8f, speed=.2f, speedJump=1.2f;
  public boolean jumping=false, crouching=false, toggleRun=false, running=false;
  public double mouseSpeed=0.006;
  private float walkSpeed=.2f, runSpeed=.4f;
  private double viewAngleXZ=0, viewAngleY=0; 
  private float gungFi=0;
  private Hud hud;
  private Weapon weapon;
  private BranchGroup rightHand;
  private TransformGroup rightHandTrans, viewTransform;
  private Vector3f positionVector;
  private Transform3D moveT3D,rotT3D;
  Vector3f velocity= new Vector3f( 0, 0, 0 );

  public Kshatriya ( SimpleUniverse universum){
    super();
    universum.addBranchGraph( this);
    viewTransform= universum.getViewingPlatform().getViewPlatformTransform();	
    positionVector= new Vector3f(0,height,0);
    moveT3D= new Transform3D();
    rotT3D= new Transform3D();
    moveT3D.setTranslation(positionVector);
    viewTransform.setTransform(moveT3D);
    hud= new Hud();
    viewTransform.addChild(hud);
    rightHand= new BranchGroup();
    rightHand.setCapability(BranchGroup.ALLOW_DETACH);
    rightHandTrans= new TransformGroup();
    rightHandTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    rightHandTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    weapon = new Spear();
    rightHandTrans.addChild(weapon);

    rightHand.addChild(rightHandTrans);
    viewTransform.addChild(rightHand);
  }

  public void gunga() {
    gungFi+=0.3;
    Transform3D t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(0f,(float)(0.01*Math.sin(gungFi)),0f));
    rightHandTrans.setTransform(t3d);
  }

  public Vector3f getVelocity() { return velocity; }
    
  public void setVelocityX( float f ) { velocity.x= f; }
  public void setVelocityY( float f ) { velocity.y= f; }
  public void setVelocityZ( float f ) { velocity.z= f; }

  public void lookUp(double fiXZ) {
    viewAngleXZ+= fiXZ;
    if( viewAngleXZ>Math.PI/4 ) viewAngleXZ=Math.PI/4;
    else if( viewAngleXZ<-Math.PI/4 ) viewAngleXZ=-Math.PI/4;
    moveT3D.rotX(viewAngleXZ);
  }

  public void turnRight(double fiY) {
    viewAngleY+= fiY;
    rotT3D.rotY(viewAngleY);
    rotT3D.mul(moveT3D);
  }

  public void setYAxisRotation( double d ) {
    turnRight(d-viewAngleY);  
	}

  public void move(Vector3f inVec) {
    Vector3f realVec = new Vector3f();
    realVec.x= -inVec.z*(float)Math.sin(viewAngleY)+inVec.x*(float)Math.cos(viewAngleY);
    realVec.z= -inVec.z*(float)Math.cos(viewAngleY)-inVec.x*(float)Math.sin(viewAngleY);
    realVec.y= inVec.y;

    positionVector.add(realVec);
    rotT3D.setTranslation(positionVector);
	
    viewTransform.setTransform(rotT3D);
  }
	
  public Vector3f getPositionVector() {
    return positionVector;
  }

  public void setPosition(Point3f p) {
     positionVector = new Vector3f(p);
  }

  public Hud getHud() {
    return hud;
  }

  public Weapon getWeapon() {
    return weapon;
  }
  
  public void setWeapon( Weapon w ) {
    rightHand.detach();
    rightHandTrans.removeChild(weapon);
    weapon=w;
    rightHandTrans.addChild(weapon);
    viewTransform.addChild(rightHand);
  }

  public void jump() {
    setVelocityY( speedJump );
    jumping=true;
  }

  public void toggleCrouch() {
    if( !crouching ) {
	   crouching=true;
		if( running ) changeSpeed();
		if( toggleRun ) toggleRun();
	   velocity.scale( .5f );
		positionVector.y=height/2f;
	 } else {
      crouching=false;
	   velocity.scale( 2 );
	   positionVector.y=height;
	 }
  }
 
  public void toggleRun() {
    if( !toggleRun ) {
	   toggleRun=true;
		velocity.scale( 2 );
		speed=runSpeed;
	 } else {
	   toggleRun=false;
		velocity.scale( .5f );
		speed=walkSpeed;
	 }
  }
  
  public void changeSpeed() {
    if( !toggleRun ) {
	   if( !running ) {
        running=true;
        velocity.scale( 2 );
        speed=runSpeed;
		} else {
        running=false;
        velocity.scale( .5f );
        speed=walkSpeed;
		}
	 }
  }
}
