import javax.vecmath.*;
import java.io.*;

public class PhysicsHandler implements Runnable {
  private Brahman myBrahman;
  private Kshatriya myKshatriya;
  private Room myRoom;
  private float timeInterval=0.02f; /* in seconds */
  private float gravity = 9.8f, marginal=.6f;
  private Vector3f p;
  private String previousDir;
  
  public PhysicsHandler (Kshatriya ks,Brahman bm){
    myBrahman = bm;
    myKshatriya = ks;
	
    Thread t= new Thread( this);
    t.start();
  }

  public void run() {
    while(true) {
      while( myBrahman.getPause() ) {}

      /* testa alla hastigheter s att man inte krockar, lgg till gravitation */
      Vector3f v = myKshatriya.getVelocity();
      if(!myKshatriya.jumping) {
        if(v.x!=0 || v.z!=0) {
          myKshatriya.gunga();
        }
      } else { 
        v.y-= gravity*timeInterval; 
      }

      myKshatriya.move(v);
      
      p = myKshatriya.getPositionVector();   
      if(p.y<=myKshatriya.height && !myKshatriya.crouching) {p.y=myKshatriya.height;v.y=0;myKshatriya.jumping=false;}

      myRoom = myBrahman.getRoom();

      for(int i=0;i<myRoom.getFileList().size();i++) {
        myRoom.fileObjects[i].rotText(myKshatriya);
      }

      if( Math.abs( Math.sqrt(p.x*p.x+p.z*p.z)+marginal )>Math.abs( myRoom.getRadius() ) ) {
        float angle = (float)Math.atan2(p.x,p.z);
        if(angle<0) angle+=Math.PI+Math.PI;
        String s = myRoom.getClosestWall(angle);
        File test= new File( s );
        if(s!="" && test.canRead() ) {
          previousDir= myRoom.getPreviousDir();
          myBrahman.setRoom(s, angle, previousDir );
        } else if( s=="" || !test.canRead() ) {
          myKshatriya.setPosition(new Point3f( (float)Math.sin(angle)*(myRoom.getRadius()-marginal), myKshatriya.height, (float)Math.cos(angle)*(myRoom.getRadius()-marginal) ) );
        }
      }

      /* should be changed to a timer */
      try {Thread.sleep((int)(timeInterval*1000f));} catch( InterruptedException ie){}
    }
  }
}