import javax.media.j3d.*;
import javax.vecmath.*;
import java.io.*;
import java.util.*;
import com.sun.j3d.utils.image.*;
import java.net.*;

public class Room extends BranchGroup{
  private static int MINNUMBEROFWALLS=8;
  private static float MINRADIUS = 10;
  private Wall[] walls;
  public FileObject[] fileObjects;
  private ArrayList directoryList;
  private ArrayList fileList;
  private float radius, marginal=.6f;
  private int height= 6, wallNumber;
  private Brahman brahman;
  private Pattern pattern;
  private float wallAngles[];
  private String previousDir, image="images/floor.jpg";
  URL imageUrl;

  /* metod fr att kunna kolla p vapenmodellerna */
  public void vapenIRummet() {
    Weapon w = new SniperRifle();
    Transform3D vapenT3D = new Transform3D();
    vapenT3D.setTranslation(new Vector3f(0,1,0));
    TransformGroup vapen = new TransformGroup(vapenT3D);
    vapen.addChild(w);
    this.addChild(vapen);
  }

  public Room( String path , Brahman brahman) {
    this.brahman= brahman;
    setCapability(BranchGroup.ALLOW_DETACH);
    directoryList = new ArrayList();
    fileList = new ArrayList();
    File dir= new File( path );
    File[] files= dir.listFiles();

    try { directoryList.add( new File(dir.getParent()) ); } catch( Exception e) {  }

    for( int i=0; i<files.length; i++ ) {
      if( files[i].isDirectory() ) {
        directoryList.add(files[i]);
      } else {
      fileList.add(files[i]);
      }
    }
    while(directoryList.size()<MINNUMBEROFWALLS) directoryList.add(null);
    radius= directoryList.size();
    if(radius<MINRADIUS) radius=MINRADIUS;
    double fi= (2*Math.PI/directoryList.size());
    double length= 2*radius*Math.tan( fi/2 );

    Shape3D floor = createFloor(radius*3);
    Shape3D ceiling = createFloor(radius*3);
   
    walls = new Wall[directoryList.size()];
    fileObjects = new FileObject[fileList.size()];

    TransformGroup[] rotatewall= new TransformGroup[directoryList.size()];
    Transform3D[] apanap= new Transform3D[directoryList.size()];
    TransformGroup[] movewall= new TransformGroup[directoryList.size()];
    Transform3D[] displacewall= new Transform3D[directoryList.size()];

    wallAngles = new float[directoryList.size()];
    /* skapa vggar */
    for( int i=0; i<directoryList.size(); i++ ) {
      try {
        walls[i]= new Wall((File)directoryList.get(i), dir, (int)length, height );
      } catch(NullPointerException e) {
        walls[i]= new Wall((int)length, height );
      }
      rotatewall[i]= new TransformGroup();
      apanap[i]= new Transform3D();
      apanap[i].rotY( i*fi );
      wallAngles[i] = (float)(i*fi);
      rotatewall[i].setTransform( apanap[i] );
	    
      movewall[i]= new TransformGroup();
      displacewall[i]= new Transform3D();
      Vector3f justMoveTheDamnWall= new Vector3f( 0, (float)(height/2f), radius );
      displacewall[i].setTranslation( justMoveTheDamnWall );
      movewall[i].setTransform( displacewall[i] );
	    
      movewall[i].addChild( walls[i] );
      rotatewall[i].addChild( movewall[i] );
      this.addChild( rotatewall[i] );     
    }

    /* skapa filer */
    pattern = new PatternRandom();
    pattern.setMinRadius(directoryList.size(),fileList.size(),radius);
    for(int i=0;i<fileList.size();i++) {
      fileObjects[i]=new FileObject((File)fileList.get(i),pattern.getPosition(i),brahman);
      addChild(fileObjects[i]);
    }

    PointLight lampa= new PointLight();
    lampa.setInfluencingBounds( new BoundingSphere( new Point3d(0,0,0), 100));
    this.addChild( lampa );
	
    TransformGroup tgceiling= new TransformGroup();
    Transform3D tfceiling= new Transform3D();
    tfceiling.rotX(Math.PI);
    tfceiling.setTranslation( new Vector3f( 0, height, 0 ) );
    tgceiling.setTransform( tfceiling );

    this.addChild( floor );
    tgceiling.addChild( ceiling );
    this.addChild( tgceiling );
  }
  
  Shape3D createFloor(float length) {
    GeometryArray g;
    Shape3D s;
    g = new QuadArray(4,QuadArray.COORDINATES|QuadArray.TEXTURE_COORDINATE_2);
    Point2f[] t=new Point2f[4];
    int wrapDistance=(int)length>>2;
    t[0]=new Point2f(0,wrapDistance);
    t[1]=new Point2f(wrapDistance,wrapDistance);
    t[2]=new Point2f(wrapDistance,0);
    t[3]=new Point2f(0,0);
    g.setTextureCoordinates(0,t);
 
    float l = length/2;
    Point3f[] tt=new Point3f[4];
    tt[0]=new Point3f(-l,0,l);
    tt[1]=new Point3f(l,0,l);
    tt[2]=new Point3f(l,0,-l);
    tt[3]=new Point3f(-l,0,-l);
    g.setCoordinates(0,tt);

    Appearance floorApp = new Appearance();
    imageUrl = Room.class.getResource(image);
 Texture tex = new TextureLoader( imageUrl, null).getTexture();
    tex.setBoundaryModeS(Texture.WRAP);
    tex.setBoundaryModeT(Texture.WRAP);
    floorApp.setTexture( tex);
    /* nr man kommenterar bort det hr s kommer frgerna tillbaka, kooonstigt va!
    TextureAttributes texAttr = new TextureAttributes();
    texAttr.setTextureMode( TextureAttributes.REPLACE);
    floorApp.setTextureAttributes(texAttr);
    */
  
    s = new Shape3D(g,floorApp);
    return s; 
  }

  String getClosestWall(float angle) {
    Transform3D t3d;
    int bestWall=0;
    float bestAngle=7;
    for(int i=0;i<wallAngles.length;i++) {
//      System.out.println(walls[i].getPath() + " " + wallAngles[i] +" "+ angle + " "+ Math.abs(wallAngles[i]-angle) );
      if(Math.abs(wallAngles[i]-angle)<bestAngle) {
          bestWall = i;
	       bestAngle = Math.abs(wallAngles[i]-angle);
		  if( i==0 && 2*Math.PI-angle<bestAngle ) {
		    bestWall=i;
			 bestAngle=2*(float)Math.PI-angle;
		  }
	   }
    }
    return walls[bestWall].getPath();
  }

  float getRadius() { return radius; }

  public ArrayList getFileList() {
    return fileList;
  }

  public String getPreviousDir() {
    previousDir=walls[0].getPreviousDirectory();  
    return previousDir;
  }

  public void setNewPositions( Kshatriya k, float angle, String previousDir ) {
    for( int i=0; i<directoryList.size(); i++ ) {
      if( walls[i].getPath().equals( previousDir ) ) wallNumber=i;
    }
    float displaceX=(float)((radius-2*marginal)*Math.sin(wallNumber*2*Math.PI/directoryList.size()));
    float displaceZ=(float)((radius-2*marginal)*Math.cos(wallNumber*2*Math.PI/directoryList.size()));
    k.setPosition(new Point3f( displaceX, k.height, displaceZ ) );
    double rotateCamera=( (wallNumber*2*Math.PI/directoryList.size()) );
    k.setYAxisRotation( rotateCamera );
  }
}
