import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.picking.*;
import java.awt.*;

public class Shotgun extends Weapon implements Runnable {
  private TransformGroup edgeOfPipe,startOfPipe;
  private TransformGroup animateTrans;
  private Transform3D animateT3D;  
  private Room room;
  private float damage=.1f, spread=(float)Math.PI/16;

  public Shotgun() {
    super();
    unlimitedAmmo=true;
  }

  TransformGroup createShape() {
    float radius=0.05f, length=2f, moveX=radius, moveY=-.5f, moveZ=-1.5f;

    Appearance weaponAppearance= new Appearance();
    Material metal= new Material();
    metal.setDiffuseColor( new Color3f( .8f, .8f, .8f ) );
    metal.setSpecularColor( new Color3f( 1f, 1f, 1f ) );
    metal.setShininess( 256 );
    weaponAppearance.setMaterial( metal );

    Transform3D rot = new Transform3D();
    rot.rotX(-Math.PI/2);

    Cylinder leftBarrel = new Cylinder( radius, length, weaponAppearance );
    TransformGroup leftBarrelGroup= new TransformGroup();
    Transform3D leftBarrelTrans= new Transform3D();
	 leftBarrelTrans.mul(rot);
    leftBarrelTrans.setTranslation( new Vector3f( -moveX, moveY, moveZ) );
	 leftBarrelGroup.setTransform( leftBarrelTrans );
	 leftBarrelGroup.addChild( leftBarrel );

    Cylinder rightBarrel = new Cylinder( radius, length, weaponAppearance );
    TransformGroup rightBarrelGroup= new TransformGroup();
    Transform3D rightBarrelTrans= new Transform3D();
	 rightBarrelTrans.mul(rot);
    rightBarrelTrans.setTranslation( new Vector3f( moveX, moveY, moveZ) );
	 rightBarrelGroup.setTransform( rightBarrelTrans );
	 rightBarrelGroup.addChild( rightBarrel );

    Box box= new Box( radius, length/2, .025f, weaponAppearance );
    TransformGroup boxGroup= new TransformGroup();
    Transform3D boxTrans= new Transform3D();
    boxTrans.mul(rot);
    boxTrans.setTranslation( new Vector3f( 0, moveY, moveZ) );
	 boxGroup.setTransform( boxTrans );
	 boxGroup.addChild( box );
 
    Transform3D t3d= new Transform3D();
    t3d.setTranslation(new Vector3f(0,0f,-1f));
    edgeOfPipe= new TransformGroup();
    edgeOfPipe.setTransform(t3d);
    edgeOfPipe.setCapability(ALLOW_LOCAL_TO_VWORLD_READ);
	 edgeOfPipe.addChild( new Text2D("+",new Color3f(0,0,0),"Arial",18,Font.PLAIN) );

    startOfPipe=new TransformGroup();
    startOfPipe.setCapability(ALLOW_LOCAL_TO_VWORLD_READ);
    
    TransformGroup trans= new TransformGroup();
    trans.addChild(leftBarrelGroup);
    trans.addChild(rightBarrelGroup);
    trans.addChild(boxGroup);
    edgeOfPipe.addChild(startOfPipe);	 
    trans.addChild(edgeOfPipe); 
    return trans;
  }

  void kill() {
    Transform3D pos1= new Transform3D();
    edgeOfPipe.getLocalToVworld(pos1);
    Vector3d v1= new Vector3d();
    pos1.get(v1);
    
    Transform3D pos0 = new Transform3D();
    startOfPipe.getLocalToVworld(pos0);
    Vector3d v0= new Vector3d();
    pos0.get(v0);

    //System.out.println("v0: "+v0.x+" "+v0.y+" "+v0.z);
    //System.out.println("v1: "+v1.x+" "+v1.y+" "+v1.z);  
    Vector3d dir = new Vector3d();
    dir.sub(v0,v1);
    
    PickTool pt = new PickTool(room);
    //pt.setMode(PickTool.GEOMETRY);
    Point3d p = new Point3d(new Point3f(v0));
    //System.out.println("pos: "+p.x+" "+p.y+" "+p.z);
    //System.out.println("dir: "+dir.x+" "+dir.y+" "+dir.z);
    
    for( int i=0; i<30; i++ ) {
      pt.setShapeRay(p,new Vector3d( dir.x+(Math.random()-.5f)*spread, dir.y+(Math.random()-.5f)*spread, dir.z+(Math.random()-.5f)*spread ));
		PickResult[] pr = pt.pickAllSorted();
      for(int n=0;n<pr.length;n++) {
        try {
          if(pr[n].getNode(PickResult.TRANSFORM_GROUP).getClass().getName().equals("FileObject")) {
            FileObject fo = (FileObject)pr[n].getNode(PickResult.TRANSFORM_GROUP);
            fo.rm( damage );
				n=pr.length;
          }
        } catch(NullPointerException np) {} 
      }
    }

  }
  
  void fireThisWeapon(Room room) {
    this.room = room;
    Thread t = new Thread(this);
    t.start();
  } 

  public void run() {
    kill();
  }
}
