import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.picking.*;
import java.awt.*;

public class SniperRifle extends Weapon implements Runnable {
  private TransformGroup edgeOfPipe,startOfPipe;
  private TransformGroup animateTrans;
  private Transform3D animateT3D;  
  private Room room;
  private float damage=1.7f, spread=(float)Math.PI/32;

  public SniperRifle() {
    super();
    unlimitedAmmo=true;
  }

  TransformGroup createShape() {
    float radius=0.05f, length=3f, moveX=.4f, moveY=-.3f, moveZ=-1.5f;

    Appearance weaponAppearance= new Appearance();
    Material metal= new Material();
    metal.setDiffuseColor( new Color3f( .8f, .8f, .8f ) );
    metal.setSpecularColor( new Color3f( 1f, 1f, 1f ) );
    metal.setShininess( 256 );
    weaponAppearance.setMaterial( metal );

    Transform3D rot = new Transform3D();
    rot.rotX(-Math.PI/2);

    Cylinder barrel = new Cylinder( radius, length, weaponAppearance );
    TransformGroup barrelGroup= new TransformGroup();
    Transform3D barrelTrans= new Transform3D();
	 barrelTrans.mul(rot);
    barrelTrans.setTranslation( new Vector3f( moveX, moveY, moveZ) );
	 barrelGroup.setTransform( barrelTrans );
	 barrelGroup.addChild( barrel );

    Cylinder scopeFront = new Cylinder( radius*1.5f, length/20, weaponAppearance );
    TransformGroup scopeFrontGroup= new TransformGroup();
    Transform3D scopeFrontTrans= new Transform3D();
	 scopeFrontTrans.mul(rot);
    scopeFrontTrans.setTranslation( new Vector3f( moveX, moveY+.14f, moveZ+.4f) );
	 scopeFrontGroup.setTransform( scopeFrontTrans );
	 scopeFrontGroup.addChild( scopeFront );

    Cone frontCone = new Cone( radius*1.5f, length/20, weaponAppearance );
    TransformGroup frontConeGroup= new TransformGroup();
    Transform3D frontConeTrans= new Transform3D();
	 frontConeTrans.mul(rot);
    frontConeTrans.setTranslation( new Vector3f( moveX, moveY+.14f, moveZ+.25f) );
	 frontConeGroup.setTransform( frontConeTrans );
	 frontConeGroup.addChild( frontCone );

    Cylinder mainScope = new Cylinder( radius, length/4, weaponAppearance );
    TransformGroup mainScopeGroup= new TransformGroup();
    Transform3D mainScopeTrans= new Transform3D();
	 mainScopeTrans.mul(rot);
    mainScopeTrans.setTranslation( new Vector3f( moveX, moveY+.14f, moveZ) );
	 mainScopeGroup.setTransform( mainScopeTrans );
	 mainScopeGroup.addChild( mainScope );

    Cone backCone = new Cone( radius*1.5f, length/20, weaponAppearance );
    TransformGroup backConeGroup= new TransformGroup();
    Transform3D backConeTrans= new Transform3D();
	 backConeTrans.mul(rot);
	 backConeTrans.mul(rot);
	 backConeTrans.mul(rot);
    backConeTrans.setTranslation( new Vector3f( moveX, moveY+.14f, moveZ-.25f) );
	 backConeGroup.setTransform( backConeTrans );
	 backConeGroup.addChild( backCone );

    Cylinder scopeBack = new Cylinder( radius*1.5f, length/20, weaponAppearance );
    TransformGroup scopeBackGroup= new TransformGroup();
    Transform3D scopeBackTrans= new Transform3D();
	 scopeBackTrans.mul(rot);
    scopeBackTrans.setTranslation( new Vector3f( moveX, moveY+.14f, moveZ-.4f) );
	 scopeBackGroup.setTransform( scopeBackTrans );
	 scopeBackGroup.addChild( scopeBack );

    Box box= new Box( radius/3, radius, length/20, weaponAppearance );
    TransformGroup boxGroup= new TransformGroup();
    Transform3D boxTrans= new Transform3D();
    boxTrans.setTranslation( new Vector3f( moveX, moveY+radius, moveZ) );
	 boxGroup.setTransform( boxTrans );
	 boxGroup.addChild( box );

    Transform3D t3d= new Transform3D();
    t3d.setTranslation(new Vector3f(0,0f,-1f));
    edgeOfPipe= new TransformGroup();
    edgeOfPipe.setTransform(t3d);
    edgeOfPipe.setCapability(ALLOW_LOCAL_TO_VWORLD_READ);
	 edgeOfPipe.addChild( new Text2D("+",new Color3f(0,0,0),"Arial",18,Font.PLAIN) );

    startOfPipe=new TransformGroup();
    startOfPipe.setCapability(ALLOW_LOCAL_TO_VWORLD_READ);
    
    TransformGroup trans= new TransformGroup();
    trans.addChild( barrelGroup );
	 trans.addChild( scopeFrontGroup );
	 trans.addChild( frontConeGroup );
	 trans.addChild( mainScopeGroup );
    trans.addChild( backConeGroup );
	 trans.addChild( scopeBackGroup );
	 trans.addChild( boxGroup );
	 
    edgeOfPipe.addChild(startOfPipe);	 
    trans.addChild(edgeOfPipe); 
    return trans;
  }

  void kill() {
    Transform3D pos1= new Transform3D();
    edgeOfPipe.getLocalToVworld(pos1);
    Vector3d v1= new Vector3d();
    pos1.get(v1);
    
    Transform3D pos0 = new Transform3D();
    startOfPipe.getLocalToVworld(pos0);
    Vector3d v0= new Vector3d();
    pos0.get(v0);

    //System.out.println("v0: "+v0.x+" "+v0.y+" "+v0.z);
    //System.out.println("v1: "+v1.x+" "+v1.y+" "+v1.z);  
    Vector3d dir = new Vector3d();
    dir.sub(v0,v1);
    
    PickTool pt = new PickTool(room);
    //pt.setMode(PickTool.GEOMETRY);
    Point3d p = new Point3d(new Point3f(v0));
    //System.out.println("pos: "+p.x+" "+p.y+" "+p.z);
    //System.out.println("dir: "+dir.x+" "+dir.y+" "+dir.z);
    
    pt.setShapeRay(p,dir);
    PickResult[] pr = pt.pickAllSorted();
    for(int n=0;n<pr.length;n++) {
      try {
        if(pr[n].getNode(PickResult.TRANSFORM_GROUP).getClass().getName().equals("FileObject")) {
          FileObject fo = (FileObject)pr[n].getNode(PickResult.TRANSFORM_GROUP);
          fo.rm( damage );
	       n=pr.length;
        }
      } catch(NullPointerException np) {} 
    }
  }
  
  void fireThisWeapon(Room room) {
    this.room = room;
    Thread t = new Thread(this);
    t.start();
  } 

  public void run() {
    kill();
  }
}
