import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Spear extends Weapon implements Runnable {
  private TransformGroup edgeOfSpear;
  private TransformGroup animateTrans;
  private Transform3D animateT3D;  
  private Room room;
  private float damage=.4f;

  public Spear() {
    super();
    unlimitedAmmo=true;
  }

  TransformGroup createShape() {
    float moveX=0.15f,moveY=0,moveZ=-1.5f,coneRadius=0.1f,coneLength=1f;
    animateT3D= new Transform3D();
    animateTrans= new TransformGroup(animateT3D);
    animateTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
 
    /* skapa spjutet */
    TransformGroup trans;
    Transform3D t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(moveX,moveY,moveZ));
    Transform3D rot = new Transform3D();
    rot.rotX(-Math.PI/2);
    t3d.mul(rot);
    trans= new TransformGroup(t3d);
      t3d = new Transform3D();
    t3d.rotZ(0.2f);
    TransformGroup rotyTrans = new TransformGroup(t3d);
    rotyTrans.addChild(animateTrans);

    /* skapa spjutspetsen */
    Cone c = new Cone(coneRadius,coneLength);
    Material m = new Material();
    m.setDiffuseColor(new Color3f(0.5f,0.5f,0.7f));
    m.setSpecularColor(new Color3f(0.9f,0.9f,1f));
    m.setEmissiveColor(new Color3f(0.5f,0.5f,0.7f));
    Appearance a = new Appearance();
    a.setMaterial(m);
    c.setAppearance(a);

    animateTrans.addChild(c);

    /* skapa handtag till spjutet */
    t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(0,-coneLength/2-.6f,0));
    TransformGroup moveCylinder = new TransformGroup(t3d);
    Cylinder cyl = new Cylinder(coneRadius/2,2f);
    m = new Material();
    m.setDiffuseColor(new Color3f(.4f,.3f,.07f));
    m.setSpecularColor(new Color3f(.7f,.2f,.2f));
    m.setShininess(1);
    m.setEmissiveColor(new Color3f(0.4f,0.3f,0.07f));
    a = new Appearance();
    a.setMaterial(m);
    cyl.setAppearance(a);
    moveCylinder.addChild(cyl);
    animateTrans.addChild(moveCylinder);
    
    trans.addChild(rotyTrans);
    
    /* definera den del av spjutet som ddar */
    t3d = new Transform3D();
    t3d.setTranslation(new Vector3f(0f,coneLength/2,0));
    edgeOfSpear = new TransformGroup(t3d);
    edgeOfSpear.setCapability(ALLOW_LOCAL_TO_VWORLD_READ);
    animateTrans.addChild(edgeOfSpear);
    
    return trans;
  }

  void kill() {
    Transform3D pos = new Transform3D();
    edgeOfSpear.getLocalToVworld(pos);
    Vector3f v = new Vector3f();
    pos.get(v);
    for(int i=0;i<room.getFileList().size();i++) {
      if(room.fileObjects[i].stabIntersect(v)) room.fileObjects[i].rm( damage );
    }
  }
  
  void fireThisWeapon(Room room) {
    this.room = room;
    Thread t = new Thread(this);
    t.start();
  } 

  public void run() {
//    System.out.println("sticker med spjutet");
	 int frames=8;
    for(int i=0;i<frames;i++) {
      animateT3D.setTranslation(new Vector3f(0f,(float)(Math.sin(Math.PI*((i+1)%frames)/frames)),0f));
      animateTrans.setTransform(animateT3D);
      if(i==frames/2) kill();
      try {Thread.sleep(20);} catch(Exception e) {}
    }
  }
}
