import java.awt.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.io.*;

public class Wall extends TransformGroup {
  private Box box;
  private Text2D text;
  private File directory, currentDir;
  private Color3f doorColor= new Color3f( .2f, .2f, .4f),
                  hiddenDoorColor=new Color3f( .4f, .4f, .4f ),
                  forbiddenDoorColor= new Color3f(.4f,.2f,.2f),
                  noDoorColor= new Color3f(.02f, .32f, .52f),
                  parentDoorColor= new Color3f(.2f, .4f, .2f);

  public Wall( File directory, File currentDir, int length, int height ) {
    this.currentDir=currentDir;
    this.directory = directory;
    createBox(length,height);
    createText();
  }
    
  public Wall(String directoryPath, int length, int height) {
	 directory = new File(directoryPath);
    createBox(length,height);
    createText();
  }
    
  public Wall(int length,int height) {
    createBox(length,height);
  }
    
  void createText() {
    String textString;
	 Transform3D t3d = new Transform3D();
    textString = directory.getName();
    try {
      if( currentDir.getParent().equals( directory.getPath() ) ) textString="..";
    } catch( Exception jaghatarfysik ) {}

    t3d.setTranslation(new Vector3f((float)(textString.length()*70/512),0,-0.2f));
    TransformGroup textMoveTrans = new TransformGroup(t3d);
    addChild(textMoveTrans);

    t3d = new Transform3D();
    t3d.rotY(Math.PI);	
    TransformGroup textRotateTrans = new TransformGroup(t3d);
    textMoveTrans.addChild(textRotateTrans);

    t3d = new Transform3D();
    t3d.setScale(4);
    TransformGroup objScale = new TransformGroup(t3d);
    textRotateTrans.addChild(objScale);
    
    try { text = new Text2D(textString,new Color3f(0,0,0),"Arial",40,Font.PLAIN); } catch( Exception ojojoj ) {}
    objScale.addChild(text);
  }

  void createBox(int wallLength, int wallHeight) {
    box = new Box( wallLength, wallHeight/2, 0.1f, setWallAppearance() );
    addChild(box);
  }

  private Appearance setWallAppearance() {
    Color3f c;

    if(directory!=null) {
      if( directory.canRead() && !directory.isHidden() ) c = doorColor;
      else if( directory.canRead() && directory.isHidden() ) c= hiddenDoorColor;
		else c = forbiddenDoorColor;
      try {
		  if( currentDir.getParent().equals( directory.getPath() ) ) c = parentDoorColor;
		} catch( Exception gurka ) {}    
	 } else c = noDoorColor;

    Appearance wallApp= new Appearance();
    Material material= new Material();
    material.setDiffuseColor( c);
    material.setShininess(128);
    material.setSpecularColor( c);
    material.setEmissiveColor( c);
    wallApp.setMaterial( material );
	 return wallApp;
  }

  String getPath() {
     if(directory!=null) return directory.getAbsolutePath();
     return "";
  }

  public String getPreviousDirectory() {
    String d=currentDir.toString();
	 return d;
  }
}
