import javax.media.j3d.*;

public abstract class Weapon extends BranchGroup {
  public TransformGroup root;
  public boolean unlimitedAmmo;
  public int ammo;

  public Weapon() {
    setCapability(ALLOW_DETACH);
    setCapability(ALLOW_CHILDREN_WRITE);
    setCapability(ALLOW_CHILDREN_EXTEND);
    root = new TransformGroup();
    root.addChild(createShape());
    addChild(root);
  }

  abstract TransformGroup createShape();
  abstract void fireThisWeapon(Room room);
 
  void fire(Room room) {
    if(!unlimitedAmmo) if(ammo==0) return;
    ammo--;
    fireThisWeapon(room);
  }
}
